"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _marked = require("marked");

var _marked2 = _interopRequireDefault(_marked);

var _babelCore = require("babel-core");

var babel = _interopRequireWildcard(_babelCore);

var _highlightJs = require("highlight.js");

var _highlightJs2 = _interopRequireDefault(_highlightJs);

var NEW_LINE = "\n";
var SPACE = " ";

function isStringEmpty(str) {
  return !_lodash2["default"].trim(str);
}

function detectSpacing(_stringArray) {

  var stringArray = _lodash2["default"].toArray(_stringArray);

  var spacingCount = (0, _lodash2["default"])(stringArray).map(function (str) {
    if (isStringEmpty(str)) return -1;
    var spaceCount = 0;
    _lodash2["default"].find(str, function (chr) {
      if (chr !== SPACE) return true;
      spaceCount++;
    });
    return spaceCount;
  }).filter(function (count) {
    return count !== -1;
  }).min();

  return spacingCount;
}

exports["default"] = function (_ref) {
  var Plugin = _ref.Plugin;
  var t = _ref.types;

  return new Plugin("babel-plugin-markdown-react", {
    metadata: {
      group: "builtin-basic"
    },
    visitor: {
      JSXElement: function JSXElement(node) {
        if (this.isJSXElement(node) && node.openingElement.name.name === 'Markdown' && node.children.length === 1) {
          var renderer = new _marked2["default"].Renderer();
          var codeRenderer = renderer.code;

          renderer.code = function () {
            var renderCode = codeRenderer.apply(renderer, _lodash2["default"].toArray(arguments));
            return renderCode.replace(/\<code\>/g, '<code class="hljs">').split(NEW_LINE).join('{String.fromCharCode(10)}');
          };

          _marked2["default"].setOptions({
            renderer: renderer,
            gfm: true,
            tables: true,
            breaks: false,
            pedantic: false,
            sanitize: true,
            smartLists: true,
            smartypants: false,
            highlight: function highlight(code) {
              return _highlightJs2["default"].highlightAuto(code).value;
            }
          });

          var strings = node.children[0].raw.split(NEW_LINE);
          var spacing = detectSpacing(strings);
          var content = (0, _lodash2["default"])(strings).map(function (str) {
            return _lodash2["default"].drop(str, spacing).join('');
          }).value().join(NEW_LINE);

          var markdownAST = babel.parse('<div>' + NEW_LINE + (0, _marked2["default"])(content).replace(/class=/g, 'className=') + NEW_LINE + '</div>');

          node.children = [markdownAST.body[0].expression];
        }
      }
    }
  });
};

module.exports = exports["default"];